/* RCS $Id: j_cosh.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: j_cosh.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:26:20  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_intv j_cosh(a_intv x)               */
/*                        a_intv x  ;                           */
/*                                                              */
/*      Arguments       : x = interval argument of tanh(x)      */
/*                                                              */
/*      Description     : Fast interval hyperbolic cosine       */
/*                        function for double IEEE              */
/*                        Floating-Point Arithmetic             */
/*                                                              */
/*      Date            : 1996-03-08                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local a_intv j_cosh(a_intv x)
#else
local a_intv j_cosh(x)

a_intv x;
#endif
{
 a_intv res;

 if (x.SUP<0)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_cosh(x.INF);
      res.SUP=res.INF*q_cshp;
      res.INF*=q_cshm;
    }
   else
    {
      res.INF=q_cosh(x.SUP)*q_cshm;
      res.SUP=q_cosh(x.INF)*q_cshp;
    }
    if (res.INF<1.0) res.INF=1.0;
 }    /* end  if (x.SUP<0) */
 else if (x.INF>0)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_cosh(x.INF);
      res.SUP=res.INF*q_cshp;
      res.INF*=q_cshm;
    }
   else
    {
      res.INF=q_cosh(x.INF)*q_cshm;
      res.SUP=q_cosh(x.SUP)*q_cshp;
    }  
    if (res.INF<1.0) res.INF=1.0;
 }
 else if (-x.INF>x.SUP)
 {
      res.INF=1.0;
      res.SUP=q_cosh(x.INF)*q_cshp;
 }
 else
 {
      res.INF=1.0;
      res.SUP=q_cosh(x.SUP)*q_cshp;
 }
return(res);
}
